Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 3211)
@@ -32,4 +32,11 @@
 
    PUBLIC   tra_adv_eiv   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
 
    !! * Substitutions
@@ -70,7 +77,14 @@
       INTEGER                         , INTENT(in   ) ::   kt       ! ocean time-step index
       CHARACTER(len=3)                , INTENT(in   ) ::   cdtype   ! =TRA or TRC (tracer indicator)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pun      ! in : 3 ocean velocity components 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvn      ! out: 3 ocean velocity components
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pwn      ! increased by the eiv
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pun      ! in : 3 ocean velocity components 
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvn      ! out: 3 ocean velocity components
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pwn      ! increased by the eiv
+
+!FTRANS pun pvn pwn :I :I :z
+      REAL(wp), INTENT(inout) ::   pun(jpi,jpj,jpk)      ! in : 3 ocean velocity components 
+      REAL(wp), INTENT(inout) ::   pvn(jpi,jpj,jpk)      ! out: 3 ocean velocity components
+      REAL(wp), INTENT(inout) ::   pwn(jpi,jpj,jpk)      ! increased by the eiv
       !!
       INTEGER  ::   ji, jj, jk                 ! dummy loop indices
@@ -105,4 +119,5 @@
       zu_eiv(:,:) = 0.e0   ;   zv_eiv(:,:) = 0.e0   ;    zw_eiv(:,:) = 0.e0  
       
+!!DCSE_NEMO: TODO - restucture loop(s) so that loop over levels is innermost
                                                     ! =================
       DO jk = 1, jpkm1                              !  Horizontal slab
@@ -165,7 +180,13 @@
             zztmp = 0.5 * rau0 * rcp 
             z2d(:,:) = 0.e0 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zztmp * u_eiv(ji,jj,jk) &
                        &         * (tsn(ji,jj,jk,jp_tem)+tsn(ji+1,jj,jk,jp_tem)) * e1u(ji,jj) * fse3u(ji,jj,jk) 
@@ -176,7 +197,13 @@
             CALL iom_put( "ueiv_heattr", z2d )                  ! heat transport in i-direction
             z2d(:,:) = 0.e0 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zztmp * v_eiv(ji,jj,jk) &
                      &           * (tsn(ji,jj,jk,jp_tem)+tsn(ji,jj+1,jk,jp_tem)) * e2v(ji,jj) * fse3v(ji,jj,jk) 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 3211)
@@ -33,4 +33,9 @@
 
    LOGICAL  :: l_trd       ! flag to compute trends
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -64,4 +69,8 @@
       USE oce     , ONLY:   zwx   => ua       , zwy   => va          ! (ua,va) used as workspace
       USE wrk_nemo, ONLY:   zslpx => wrk_3d_1 , zslpy => wrk_3d_2    ! 3D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx zwy zslpx zslpy :I :I :z
+
       !
       INTEGER                              , INTENT(in   ) ::   kt              ! ocean time-step index
@@ -69,7 +78,19 @@
       INTEGER                              , INTENT(in   ) ::   kjpt            ! number of tracers
       REAL(wp), DIMENSION(        jpk     ), INTENT(in   ) ::   p2dt            ! vertical profile of tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb             ! before tracer field
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb             ! before tracer field
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+!FTRANS pun pvn pwn :I :I :z
+!FTRANS ptb :I :I :z :
+!FTRANS pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   pun(jpi,jpj,jpk)        ! ocean velocity component (u)
+      REAL(wp), INTENT(in   ) ::   pvn(jpi,jpj,jpk)        ! ocean velocity component (v)
+      REAL(wp), INTENT(in   ) ::   pwn(jpi,jpj,jpk)        ! ocean velocity component (w)
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)   ! tracer fields (before)
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)   ! tracer trend 
+
       !
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -100,7 +121,13 @@
          zwx(:,:,jpk) = 0.e0   ;   zwy(:,:,jpk) = 0.e0        ! bottom values
          ! interior values
+#if defined key_z_first
+         DO jj = 1, jpjm1      
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpjm1      
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   zwx(ji,jj,jk) = umask(ji,jj,jk) * ( ptb(ji+1,jj,jk,jn) - ptb(ji,jj,jk,jn) )
                   zwy(ji,jj,jk) = vmask(ji,jj,jk) * ( ptb(ji,jj+1,jk,jn) - ptb(ji,jj,jk,jn) )
@@ -113,7 +140,13 @@
          !                                             !-- Slopes of tracer
          zslpx(:,:,jpk) = 0.e0   ;   zslpy(:,:,jpk) = 0.e0    ! bottom values
+#if defined key_z_first
+         DO jj = 2, jpj                                       ! interior values
+            DO ji = 2, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                                     ! interior values
             DO jj = 2, jpj
                DO ji = fs_2, jpi   ! vector opt.
+#endif
                   zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji-1,jj  ,jk) )   &
                      &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
@@ -124,7 +157,13 @@
          END DO
          !
+#if defined key_z_first
+         DO jj = 2, jpj                                       ! Slopes limitation
+            DO ji = 2, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                                     ! Slopes limitation
             DO jj = 2, jpj
                DO ji = fs_2, jpi   ! vector opt.
+#endif
                   zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
                      &                                                 2.*ABS( zwx  (ji-1,jj,jk) ),   &
@@ -138,8 +177,15 @@
 
          !                                             !-- MUSCL horizontal advective fluxes
+#if defined key_z_first
+         DO jj = 2, jpjm1                                     ! interior values
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+                  zdt  = p2dt(jk)
+#else
          DO jk = 1, jpkm1                                     ! interior values
             zdt  = p2dt(jk)
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ! MUSCL fluxes
                   z0u = SIGN( 0.5, pun(ji,jj,jk) )
@@ -163,7 +209,13 @@
          !
          ! Tracer flux divergence at t-point added to the general trend
+#if defined key_z_first
+         DO jj = 2, jpjm1      
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1      
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! horizontal advective trends
@@ -189,14 +241,33 @@
          ! -----------------------------
          !                                             !-- first guess of the slopes
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zwx(ji,jj,1) = 0.e0                             ! surface boundary conditions
+               DO jk = 2, jpkm1                                ! interior values
+                  zwx(ji,jj,jk) = tmask(ji,jj,jk) * ( ptb(ji,jj,jk-1,jn) - ptb(ji,jj,jk,jn) )
+               END DO
+               zwx(ji,jj,jpk) = 0.e0                           ! bottom boundary conditions
+            END DO
+         END DO
+#else
          zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0    ! surface & bottom boundary conditions
          DO jk = 2, jpkm1                                     ! interior values
             zwx(:,:,jk) = tmask(:,:,jk) * ( ptb(:,:,jk-1,jn) - ptb(:,:,jk,jn) )
          END DO
+#endif
 
          !                                             !-- Slopes of tracer
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zslpx(ji,jj,1) = 0.e0                          ! surface values
+               DO jk = 2, jpkm1                               ! interior value
+#else
          zslpx(:,:,1) = 0.e0                                  ! surface values
          DO jk = 2, jpkm1                                     ! interior value
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji,jj,jk+1) )   &
                      &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
@@ -205,7 +276,13 @@
          END DO
          !                                             !-- Slopes limitation
+#if defined key_z_first
+         DO jj = 1, jpj   
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1                               ! interior values
+#else
          DO jk = 2, jpkm1                                     ! interior values
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
                      &                                                 2.*ABS( zwx  (ji,jj,jk+1) ),   &
@@ -220,8 +297,15 @@
          ENDIF 
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1                                     ! interior values
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+                  zdt  = p2dt(jk)
+#else
          DO jk = 1, jpkm1                                     ! interior values
             zdt  = p2dt(jk)
             DO jj = 2, jpjm1      
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3w(ji,jj,jk+1) )
                   z0w = SIGN( 0.5, pwn(ji,jj,jk+1) )
@@ -236,7 +320,13 @@
 
          ! Compute & add the vertical advective trend
+#if defined key_z_first
+         DO jj = 2, jpjm1      
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1      
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! vertical advective trends 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 3211)
@@ -32,4 +32,9 @@
    LOGICAL  :: l_trd       ! flag to compute trends
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -62,4 +67,7 @@
       USE oce     , ONLY:   zwx   => ua       , zwy   => va         ! (ua,va) used as 3D workspace
       USE wrk_nemo, ONLY:   zslpx => wrk_3d_1 , zslpy => wrk_3d_2   ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx zwy zslpx zslpy :I :I :z
+
       !!
       INTEGER                              , INTENT(in   ) ::   kt              ! ocean time-step index
@@ -67,7 +75,20 @@
       INTEGER                              , INTENT(in   ) ::   kjpt            ! number of tracers
       REAL(wp), DIMENSION(        jpk     ), INTENT(in   ) ::   p2dt            ! vertical profile of tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before & now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before & now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+!FTRANS pun pvn pwn :I :I :z
+!FTRANS ptb ptn :I :I :z :
+!FTRANS pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   pun(jpi,jpj,jpk)        ! ocean velocity component (u)
+      REAL(wp), INTENT(in   ) ::   pvn(jpi,jpj,jpk)        ! ocean velocity component (v)
+      REAL(wp), INTENT(in   ) ::   pwn(jpi,jpj,jpk)        ! ocean velocity component (w)
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)   ! tracer fields (before)
+      REAL(wp), INTENT(in   ) ::   ptn(jpi,jpj,jpk,kjpt)   ! tracer fields (now)
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)   ! tracer trend 
+
       !!
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -98,7 +119,13 @@
          zwx(:,:,jpk) = 0.e0   ;   zwy(:,:,jpk) = 0.e0        ! bottom values
          ! interior values
+#if defined key_z_first
+         DO jj = 1, jpjm1      
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpjm1      
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   zwx(ji,jj,jk) = umask(ji,jj,jk) * ( ptb(ji+1,jj,jk,jn) - ptb(ji,jj,jk,jn) )
                   zwy(ji,jj,jk) = vmask(ji,jj,jk) * ( ptb(ji,jj+1,jk,jn) - ptb(ji,jj,jk,jn) )
@@ -111,7 +138,13 @@
          !                                             !-- Slopes of tracer
          zslpx(:,:,jpk) = 0.e0   ;   zslpy(:,:,jpk) = 0.e0    ! bottom values
+#if defined key_z_first
+         DO jj = 2, jpj                                       ! interior values
+            DO ji = 2, jpi
+               DO jk = 1, jpkm1 
+#else
          DO jk = 1, jpkm1                                     ! interior values
             DO jj = 2, jpj
                DO ji = fs_2, jpi   ! vector opt.
+#endif
                   zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji-1,jj  ,jk) )   &
                      &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
@@ -122,7 +155,13 @@
          END DO
          !
+#if defined key_z_first
+         DO jj = 2, jpj                                       ! Slopes limitation
+            DO ji = 2, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                                     ! Slopes limitation
             DO jj = 2, jpj
                DO ji = fs_2, jpi   ! vector opt.
+#endif
                   zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
                      &                                                 2.*ABS( zwx  (ji-1,jj,jk) ),   &
@@ -132,12 +171,19 @@
                      &                                                 2.*ABS( zwy  (ji,jj  ,jk) ) )
                END DO
-           END DO
+            END DO
          END DO             ! interior values
 
         !                                             !-- MUSCL horizontal advective fluxes
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1                               ! interior values
+                  zdt  = p2dt(jk)
+#else
          DO jk = 1, jpkm1                                     ! interior values
             zdt  = p2dt(jk)
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ! MUSCL fluxes
                   z0u = SIGN( 0.5, pun(ji,jj,jk) )
@@ -159,7 +205,13 @@
 
          !!  centered scheme at lateral b.C. if off-shore velocity
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   IF( umask(ji,jj,jk) == 0. ) THEN
                      IF( pun(ji+1,jj,jk) > 0. .AND. ji /= jpi ) THEN
@@ -184,7 +236,13 @@
 
          ! Tracer flux divergence at t-point added to the general trend
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! horizontal advective trends 
@@ -194,5 +252,5 @@
                   pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + ztra
                END DO
-           END DO
+            END DO
          END DO
          !                                 ! trend diagnostics (contribution of upstream fluxes)
@@ -211,14 +269,33 @@
          ! -----------------------------
          !                                             !-- first guess of the slopes
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zwx(ji,jj,1) = 0.e0                     ! surface boundary conditions
+               DO jk = 2, jpkm1                        ! interior values
+                  zwx(ji,jj,jk) = tmask(ji,jj,jk) * ( ptb(ji,jj,jk-1,jn) - ptb(ji,jj,jk,jn) )
+               END DO
+               zwx(ji,jj,jpk) = 0.e0                   ! bottom boundary conditions
+            END DO
+         END DO
+#else
          zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0    ! surface & bottom boundary conditions
          DO jk = 2, jpkm1                                     ! interior values
             zwx(:,:,jk) = tmask(:,:,jk) * ( ptb(:,:,jk-1,jn) - ptb(:,:,jk,jn) )
          END DO
+#endif
 
          !                                             !-- Slopes of tracer
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zslpx(ji,jj,1) = 0.e0                          ! surface values
+               DO jk = 2, jpkm1                               ! interior value
+#else
          zslpx(:,:,1) = 0.e0                                  ! surface values
          DO jk = 2, jpkm1                                     ! interior value
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji,jj,jk+1) )   &
                      &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
@@ -227,7 +304,13 @@
          END DO
          !                                             !-- Slopes limitation
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1                               ! interior values
+#else
          DO jk = 2, jpkm1                                     ! interior values
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
                      &                                                 2.*ABS( zwx  (ji,jj,jk+1) ),   &
@@ -242,8 +325,15 @@
          ENDIF
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1                                     ! interior values
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+                  zdt  = p2dt(jk)
+#else
          DO jk = 1, jpkm1                                     ! interior values
             zdt  = p2dt(jk)
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3w(ji,jj,jk+1) )
                   z0w = SIGN( 0.5, pwn(ji,jj,jk+1) )
@@ -257,7 +347,13 @@
          END DO
          !
-         DO jk = 2, jpkm1        ! centered near the bottom
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1         ! centered near the bottom
+#else
+         DO jk = 2, jpkm1               ! centered near the bottom
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   IF( tmask(ji,jj,jk+1) == 0. ) THEN
                      IF( pwn(ji,jj,jk) > 0. ) THEN
@@ -269,7 +365,13 @@
          END DO
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1        ! Compute & add the vertical advective trend
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1        ! Compute & add the vertical advective trend
             DO jj = 2, jpjm1      
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! vertical advective trends 
